package net.lensfrex.oj.collector.utils;

import org.apache.commons.codec.digest.DigestUtils;
import org.apache.http.HttpEntity;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.ResponseHandler;
import org.apache.http.client.config.CookieSpecs;
import org.apache.http.client.config.RequestConfig;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.StringEntity;
import org.apache.http.impl.client.BasicResponseHandler;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClients;
import org.apache.http.util.EntityUtils;

import java.io.IOException;
import java.io.InputStream;
import java.net.InetAddress;
import java.net.NetworkInterface;
import java.net.URL;
import java.net.URLConnection;
import java.util.Map;

public class NetworkUtil {

    public static final String REQUEST_USERAGENT = "Mozilla/5.0 (Windows NT 10.0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/99.0.7113.93 Safari/537.36";

    public static String post(String url, String data, Map<String, String> headers) throws IOException {
        CloseableHttpClient httpClient = HttpClients.createDefault();
        RequestConfig requestConfig = RequestConfig.custom().setCookieSpec(CookieSpecs.STANDARD).build();

        HttpPost httpPost = new HttpPost(url);
        httpPost.setConfig(requestConfig);

        for (String key : headers.keySet()) {
            httpPost.setHeader(key, headers.get(key));
        }

        ResponseHandler<String> responseHandler = new BasicResponseHandler();

        httpPost.setEntity(new StringEntity(data, "utf-8"));
        String response = httpClient.execute(httpPost, responseHandler);
        httpClient.close();

        return response;
    }

    public static String get(String url, Map<String, String> headers) throws IOException {
        CloseableHttpClient httpClient = HttpClients.createDefault();
//        HttpGet httpGet = new HttpGet("https://oj.wust-acm.top/api/problem?paging=true&offset=0&limit=10&page=1");
        HttpGet httpGet = new HttpGet(url);

//        httpGet.setHeader("User-Agent", REQUEST_USERAGENT);
//        httpGet.setHeader("Host", "oj.wust-acm.top");
//        httpGet.setHeader("cookie", "_ga=GA1.2.829022655.1645538223; _gid=GA1.2.744163698.1657197518; csrftoken=6iT1oJ4KAqz8GOQidnnxk3nvNstEQSPhiEc8T9yKdEwN4nes7s09pdfZ9aw4Ao7k; sessionid=oh6wf39nblzc5h4aaifvzvievk386hsn");
//        httpGet.setHeader("accept-encoding", "gzip, deflate, br");

        for (String key : headers.keySet()) {
            httpGet.setHeader(key, headers.get(key));
        }

        ResponseHandler<String> responseHandler = httpResponse -> {
            int status = httpResponse.getStatusLine().getStatusCode();

//            System.out.println("code: " + status);

            if (status >= 200 && status < 300) {
                HttpEntity entity = httpResponse.getEntity();

                return entity != null ? EntityUtils.toString(entity) : null;
            } else {
                throw new ClientProtocolException("??");
            }
        };

        String response = httpClient.execute(httpGet, responseHandler);
        httpClient.close();

        return response;
    }

    public static byte[] download(String url) {
        try {
            URL requestUrl = new URL(url);
            URLConnection connection = requestUrl.openConnection();

            connection.setRequestProperty("user-agent", REQUEST_USERAGENT);

            InputStream inputStream = connection.getInputStream();

            return IOUtil.readDataFromInputStream(inputStream, 15);
        } catch (Exception e) {
            e.printStackTrace();
            return null;
        }
    }

    public static String getMacMD5() {
        try {
            byte[] mac = NetworkInterface.getByInetAddress(InetAddress.getLocalHost()).getHardwareAddress();
            StringBuffer sb = new StringBuffer();

            for (byte b : mac) {
                String s = Integer.toHexString(b & 0xFF);
                sb.append(s.length() == 1 ? 0 + s : s);
            }
            return DigestUtils.md5Hex(sb.toString().toUpperCase());
        } catch (Exception e) {
            return DigestUtils.md5Hex("(+_+)?");
        }
    }
}
