package net.lensfrex.oj.collector.utils;

import java.util.ArrayList;
import java.util.Map;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class ParamFiller {
    private static final String REG = "\\{\\{(.+?)\\}\\}";
    private static final Pattern pattern = Pattern.compile(REG);

    public static String fill(String template, Map<String, String> data) {
        Matcher matcher = pattern.matcher(template);

        StringBuffer stringBuffer = new StringBuffer();
        String key = "", value = "";
        while (matcher.find()) {
            key = matcher.group(1);
            value = data.get(key);

            if (value != null) {
                // 直接正则替换遇到$会报错
                value = value.replace("$", "＄");
            }
            matcher.appendReplacement(stringBuffer, value == null ? "" : value);
        }

        matcher.appendTail(stringBuffer);
        return stringBuffer.toString();
    }

    private static ArrayList<String> getParams(String template) {
        Matcher matcher = pattern.matcher(template);

        ArrayList<String> result = new ArrayList<>();

        while (matcher.find()) {
            result.add(matcher.group(1));
        }

        return result;
    }
}
